#type vertex
#version 450 core

layout(location = 0) in float a_ScreenSpace;
layout(location = 1) in vec4 a_Position;
layout(location = 2) in vec4 a_Color;
layout(location = 3) in vec2 a_TexCoord;
layout(location = 4) in float a_TextureTilingFactor;
layout(location = 5) in vec3 a_Normal;

layout(std140, binding = 0) uniform Camera { mat4 u_ViewProjection; };
layout(std140, binding = 1) uniform Color { vec4 u_tintColor;
mat4 u_transform; };

struct VertexOutput {
  vec4 Position;
  vec4 Color;
  vec2 TexCoord;
  float TextureTilingFactor;
  vec3 Normal;
};

layout(location = 0) out VertexOutput Output;

void main() {
  vec4 newTransform = u_ViewProjection * u_transform * a_Position;
  Output.Position = newTransform;
  Output.Color = a_Color * u_tintColor;
  Output.TexCoord = a_TexCoord;
  Output.TextureTilingFactor = 1;
  Output.Normal = a_Normal;
  
  gl_Position = newTransform;
}

#type fragment
#version 450 core

layout(location = 0) out vec4 color;

struct VertexOutput {
  vec4 Position;
  vec4 Color;
  vec2 TexCoord;
  float TextureTilingFactor;
  vec3 Normal;
};

layout(location = 0) in VertexOutput Input;

layout(binding = 0) uniform sampler2D u_Texture;

void main() {

  float a = texture(u_Texture, Input.TexCoord.xy).r;
  color = vec4(Input.Color.rgb, Input.Color.a*a);

  if(color.a < 0.5)
    discard;
}
